# This file is placed in the Public Domain.


"object programming tests"


import os
import sys


sys.path.insert(0, os.getcwd())


import unittest


from op import Object, update


from op.function import edit
from op.kernel import Cfg
from op.parse import parse


class Test_Cfg(unittest.TestCase):

    def test_parse(self):
        p = Cfg()
        parse(p, "mod=irc")
        self.assertEqual(p.sets.mod, "irc")

    def test_parse2(self):
        p = Cfg()
        parse(p, "mod=irc,rss")
        self.assertEqual(p.sets.mod, "irc,rss")

    def test_edit(self):
        d = Object()
        update(d, {"mod": "irc,rss"})
        edit(Cfg, d)
        self.assertEqual(Cfg.mod, "irc,rss")
